
import lejos.nxt.remote.NXTCommand;
import lejos.pc.comm.NXTComm;
import lejos.pc.comm.NXTCommFactory;
import lejos.pc.comm.NXTConnector;
import lejos.pc.comm.NXTInfo;

public class BarChartController {
	static byte nspeedo = -40;
	static byte speedo = 40;
	static int time = 2000;
	public static boolean testing = false;
	
	static NXTCommand command[] = new NXTCommand[2];
	static int barlocs[] = new int[5];
	
	static void init() throws Exception {
	  
	  System.out.println("INIT BARCHART CONTROLLER");
	  
	   if (testing) return;
	  
	   NXTConnector conn = new NXTConnector();
	    NXTInfo info[] = conn.search("", null, NXTCommFactory.USB);
	    NXTComm comm[] = new NXTComm[2];
	    
	    boolean swap = false;
	    System.out.println("FOUND " + info.length + " bricks");
	    for (int i = 0; i < info.length; i++) {
	      System.out.println(info[i].name);
	      if (i == 0 && info[i].name.toLowerCase().indexOf("doug") >= 0) {
	        swap = true;
	      }
	      		
	      // connect to doug's and wills NXT
	      comm[i] = NXTCommFactory.createNXTComm(info[i].protocol);
	      comm[i].open(info[i], NXTComm.LCP);
	      command[i] = new NXTCommand();
	      command[i].setNXTComm(comm[i]);
	    }
	    
	    if (swap) {
	      System.out.println("SWAPPING COMMANDS.");
  	    NXTCommand commandtmp = command[0];
  	    command[0] = command[1];
  	    command[1] = commandtmp;
	    } else {
	      System.out.println("NOT SWAPPING COMMANDS.");
	    }
	    // reset tachs
	    command[0].resetMotorPosition(0, false);
	    command[0].resetMotorPosition(1, false);
	    command[0].resetMotorPosition(2, false);
	    
	    command[1].resetMotorPosition(0, false);
	    command[1].resetMotorPosition(1, false);
	}
	
	public static void shutdown() throws Exception {
	  System.out.println("SHUTDOWN BARCHART CONTROLLER");
	   if (testing) return;
	  
     for (int i = 0; i < 5; i++) {
       updateBar(i, 0);
     }
	   
	   command[0].close();
     command[1].close();
	}
	
	public static void updateBars(int arr[]) throws Exception {
	  int min = Integer.MAX_VALUE;
	  int max = Integer.MIN_VALUE;
	  for (int i = 0; i < arr.length; i++) {
	    if (arr[i] < min) {
	      min = arr[i];
	    }
	    
	    if (arr[i] > max) {
	      max = arr[i];
	    }
	  }
	  
	  double diff = max - min;
	  
	  if (diff == 0) {
	    // empty data, set the bars to zero
	    for (int i = 0; i < 5; i++) {
	      updateBar(i, 0);
	    }
	    return;
	  }
	  
	  // otherwise, we need to recalc each value based on the min and max
	  for (int i = 0; i < 5; i++) {
	    updateBar(i, (int)((arr[i] - min) / diff * 1100));
	  }
	  
	}
	
	public static void main(String args[] ) throws Exception{
		init();
		
		updateBar(0, 200);
		updateBar(1, 400);
		updateBar(2, 600);
		updateBar(3, 800);
		updateBar(4, 1000);
		
		Thread.sleep(time);
		
		updateBar(0, 1000);
		updateBar(1, 800);
		updateBar(2, 600);
		updateBar(3, 400);
		updateBar(4, 200);
		
		Thread.sleep(time);
		
		updateBar(0, 100);
		updateBar(1, 400);
		updateBar(2, 1100);
		updateBar(3, 400);
		updateBar(4, 100);
		
		Thread.sleep(time);
		
		updateBar(0, 700);
		updateBar(1, 800);
		updateBar(2, 900);
		updateBar(3, 1000);
		updateBar(4, 1100);
		
		Thread.sleep(time);
		
    updateBar(0, 700);
    updateBar(1, 600);
    updateBar(2, 500);
    updateBar(3, 400);
    updateBar(4, 300);

    Thread.sleep(time);
    
    updateBar(0, 0);
    updateBar(1, 0);
    updateBar(2, 100);
    updateBar(3, 200);
    updateBar(4, 300);

    
		Thread.sleep(time);
		
		updateBar(0, 0);
		updateBar(1, 0);
		updateBar(2, 0);
		updateBar(3, 0);
		updateBar(4, 0);

    Thread.sleep(time);
    
    updateBar(0, 0);
    updateBar(1, 0);
    updateBar(2, 0);
    updateBar(3, 0);
    updateBar(4, 1100);

    Thread.sleep(time);
    
    updateBar(0, 0);
    updateBar(1, 0);
    updateBar(2, 0);
    updateBar(3, 1100);
    updateBar(4, 1000);

    Thread.sleep(time);
    
    updateBar(0, 0);
    updateBar(1, 0);
    updateBar(2, 1100);
    updateBar(3, 1000);
    updateBar(4, 900);

    Thread.sleep(time);
    
    updateBar(0, 0);
    updateBar(1, 1100);
    updateBar(2, 1000);
    updateBar(3, 900);
    updateBar(4, 800);

    Thread.sleep(time);
    
    updateBar(0, 1100);
    updateBar(1, 1000);
    updateBar(2, 900);
    updateBar(3, 800);
    updateBar(4, 700);

    Thread.sleep(time);
    
    updateBar(0, 0);
    updateBar(1, 0);
    updateBar(2, 0);
    updateBar(3, 0);
    updateBar(4, 0);
    
    shutdown();
	}
	
	static void updateBar(int barnum, int val) throws Exception {
	  System.out.println("UPDATE BARCHART " + barnum + " " + val);
	  if (testing) return;
	  
		// figure out difference in tachometer
		// updated based on current tacho count
		if (barnum < 3) {
			barlocs[barnum] = -command[0].getTachoCount(barnum);
		} else {
			barlocs[barnum] = -command[1].getTachoCount(barnum - 3);
		}
		
		int diff = barlocs[barnum] - val;
		byte speed = nspeedo;
		if (diff == 0) {
			return;
		}
		if (diff > 0) {
			speed = (byte) (Math.abs(diff) / 11.0);
			
			
			//speed = speedo;
		} else {
			speed = (byte) (- Math.abs(diff) / 11.0);
		//	speed = nspeedo;
		}
		
		System.out.println("BARLOC: " + barlocs[barnum] + ", SPEED: " + speed + ", DIFF: " + diff + " TACHO: " + command[0].getTachoCount(0));
		
		if (barnum < 3) {
			// first nxt
			// DOES THIS BLOCK?
			command[0].setOutputState(barnum, speed, 0, 0, 0, 0, Math.abs(diff));
		} else {
			command[1].setOutputState(barnum - 3, speed, 0, 0, 0, 0, Math.abs(diff));
		}
		
		System.out.println("ACTUAL TACHO: " + command[0].getTachoCount(0));
		
		barlocs[barnum] = val;
	}
}
